/*******************************************************************
 * This is a demonstration of the use of a function template.
 *******************************************************************/

#include<iostream>
#include<string>
#include<vector>
#include<string>
using namespace std;
/* If b and e are iterators to a container
 * of objects of type T, then my_count returns the number of occurences
 * of the value t in [b,e).
 */ 	
template <class iterator, class T>
iterator my_find(const iterator & b, const iterator & e, T t);

template <class iterator, class T>
iterator my_find_if(const iterator & b, const iterator & e, bool p(const T&));

bool positive(const float& x)
{
	return x>0;
}
	
int main()
{
	float x;
	vector<float> nums;
	string trash;
	cout<<"Please enter some floating point values. "<<
		"Enter 's' to stop. ";
	while(cin>>x)
		nums.push_back(x);
	cin.clear();
	cin>>trash;//Get the stop word to discard.
	cout<<"\nWhat value would you like to find?  ";
	cin>>x;
	vector<float>::iterator it=my_find(nums.begin(),nums.end(),x);
	if(it!=nums.end())
		cout<<endl<<*it<<" found.\n";
	else
		cout<<endl<<x<<" not found.\n";
	it=my_find_if(nums.begin(),nums.end(),positive);
	if(it!=nums.end())
		cout<<endl<<*it<<" is the first positive value\n";
	else
		cout<<endl<<"No positive values found.\n";
	
	return 0;
}

template <class iterator, class T>
iterator my_find(const iterator & b, const iterator & e, T t)
{
	iterator ret=b;
	while(ret!=e && *ret!=t)
		ret++;
	return ret;
}

template <class iterator, class T>
iterator my_find_if(const iterator & b, const iterator & e, bool p(const T& t))
{
	iterator ret=b;
	while(ret!=e && !p(*ret))
		ret++;
	return ret;
}
